#include <cstring>
#include <vector>
#include <iostream>
#include <fstream>
using namespace std;
#include "define.h"

#include "Parser.h"



void Parser::SynErr(int n) {
	if (errDist >= minErrDist) errors->SynErr(la->line, la->col, n);
	errDist = 0;
}

void Parser::SemErr(char* msg) {
	if (errDist >= minErrDist) errors->Error(t->line, t->col, msg);
	errDist = 0;
}

void Parser::Get() {
	for (;;) {
		t = la;
		la = scanner->Scan();
		if (la->kind <= maxT) { ++errDist; break; }

		if (dummyToken != t) {
			dummyToken->kind = t->kind;
			dummyToken->pos = t->pos;
			dummyToken->col = t->col;
			dummyToken->line = t->line;
			dummyToken->next = NULL;
			coco_string_delete(dummyToken->val);
			dummyToken->val = coco_string_create(t->val);
			t = dummyToken;
		}
		la = t;
	}
}

void Parser::Expect(int n) {
	if (la->kind==n) Get(); else { SynErr(n); }
}

bool Parser::StartOf(int s) {
	return set[s][la->kind];
}

void Parser::ExpectWeak(int n, int follow) {
	if (la->kind == n) Get();
	else {
		SynErr(n);
		while (!StartOf(follow)) Get();
	}
}

bool Parser::WeakSeparator(int n, int syFol, int repFol) {
	bool *s = new bool[maxT+1];
	if (la->kind == n) {Get(); delete s; return true;}
	else if (StartOf(repFol)) {delete s; return false;}
	else {
		for (int i=0; i <= maxT; i++) {
			s[i] = set[syFol][i] || set[repFol][i] || set[0][i];
		}
		SynErr(n);
		while (!s[la->kind]) Get();
		delete s;
		return StartOf(syFol);
	}
}

void Parser::Pcn() {
		parN = 0;
		defN = 0;
		parNB = 0;
		tupN = 0;
		listN = 0;
		quantN = 0;
		tab = new vector<string>(); 
		ext = new vector<string>();
		parF = new vector<ofstream *>();
		tupleN = new vector<unsigned int>();
		listN = new vector<unsigned int>();
		
		parF->push_back(new ofstream());
		
		ofstream * o = parF->back();
		
		inclFile = new ofstream();
		inclFile2 = new ofstream();
		
		inclFile->open("incl_data.h");
		inclFile2->open("incl_data.cpp");
		
		
		
			 o->open("main");
			 
			 *o << "#include \"defvar.h\"" << endl << endl;
			 *o << "#include \"incl_data.h\"" << endl << endl;
			 
			 *inclFile << "#include \"defvar.h\"" << endl << endl;
			 
			 //*inclFile << "char * _xxx_char_var_helper_var0123456789;" << endl << endl;
			 
			 *inclFile2 << "#include \"defvar.h\"" << endl;
			 *inclFile2 << "#include \"incl_data.h\"" << endl << endl;
		
					 string * s = new string("");
					 
				
		*o << endl << endl << s->c_str() << endl << endl;
		
		
		ProgramDeclaration();
		while (la->kind == 1) {
			ProgramDeclaration();
		}
		s = new string("parF");
		char * c = new char[80];
		
		*inclFile << endl << endl;
		
		for (unsigned int i = 1; i <= parN; i++)
		{					
		
				*inclFile	<< "void WINAPI " << s->c_str() << i << "( " << s->c_str() << i << "a & " 
							<< s->c_str() << i << "aa );" << endl;		
		
			}
		
			o->close();
			inclFile->close();
			inclFile2->close();
					
		
}

void Parser::ProgramDeclaration() {
		vector<string> * defvars = new vector<string>();	
		vector<string> * defvarsType = new vector<string>();
		
		
		
		ProgramHeading(defvars, defvarsType);
		ofstream * o = parF->back();
		
		
		
							 *o << "{" << endl; 
		
							 unsigned int type = 0;
							 string * r = new string("");
							 string * rr = new string("");
							 vector<string *> * rrr = new vector<string *>();
							 vector<string *> * r4 = new vector<string *>();
							 
		
							 
		while (StartOf(1)) {
			if (la->kind == 11) {
				Get();
				*o << "int " ;
				type = 0;
				
			} else if (la->kind == 12) {
				Get();
				*o << "double " ;
				type = 1;
				
			} else if (la->kind == 13) {
				Get();
				*o << "char " ;
				type = 2;
				
			} else if (la->kind == 14) {
				Get();
				*o << "int " ;
				type = 3;
				
			} else {
				Get();
				Expect(8);
				type = 4; 
				
					*o << "DefVar" << t->val << " ";
					
					defvarsType->push_back(t->val);
					
				
			}
			string * post = new string("");
			
			
			MutableDeclarationList(type, r, rr, rrr, r4, defvars, defvarsType, post);
			Expect(16);
			*o << ";" << endl; 
			*o << post->c_str() << endl;
			if(la->kind == _bracket2);
			else 
			{
			
											//r->append(" ");
											rr->append(", ");
			
										}
			
									
		}
		*o << endl; 
		bool s = false;				
		
		
		ProgramBody(s, r, rr, rrr, r4, defvars, defvarsType);
		*o  << endl << "}" << endl;
		delete r;
		delete rr;
		delete rrr;
		delete r4;
		
							
}

void Parser::ProgramHeading(xxx_type_1234567890 * & defvars, xxx_type_1234567890 * & defvarsType) {
		ofstream * o = parF->back(); 
		Expect(1);
		*o << endl << "void " << t->val;
		*inclFile << endl << "void " << t->val;
		
		
		Expect(6);
		*o << "(" ;
		*inclFile << "(";
		
		
		if (la->kind == 15) {
			Get();
			Expect(8);
			defvarsType->push_back(t->val); 
			Expect(1);
			*o << "DefVar" << defvarsType->back().c_str() << " & " << t->val ;
			*inclFile << "DefVar" << defvarsType->back().c_str() << " & " << t->val ;
			defvars->push_back(t->val);
			tab->push_back(t->val);
			
											
			while (la->kind == 17) {
				Get();
				*o << ", " ;
				*inclFile << ", ";
				
				
				Expect(15);
				Expect(8);
				defvarsType->push_back(t->val); 
				Expect(1);
				*o << "DefVar" << defvarsType->back().c_str() << " & " << t->val ;
				*inclFile << "DefVar" << defvarsType->back().c_str() << " & " << t->val ;
				defvars->push_back(t->val);
				tab->push_back(t->val);
				
				
			}
		}
		Expect(18);
		*o << ")" << endl;
		*inclFile << ");" << endl << endl;
		
		
}

void Parser::MutableDeclarationList(unsigned int & type, string * & r, string * & rr, xxx_type2_1234567890 * & rrr, 
xxx_type2_1234567890 * & r4, xxx_type_1234567890 * & defvars, xxx_type_1234567890 * & defvarsType,
string * & post) {
		ofstream * o = parF->back(); 
		MutableDeclaration(type, r, rr, rrr, r4, defvars, defvarsType, post);
		while (la->kind == 17) {
			Get();
			*o << ", " ; 
			//r->append(", ");
			rr->append(", ");
			
			if (type == 4)
			{
			
				defvarsType->push_back(defvarsType->back());
			
			}
			
										
			MutableDeclaration(type, r, rr, rrr, r4, defvars, defvarsType, post);
		}
}

void Parser::ProgramBody(bool & state, string * & r, string * & rr, xxx_type2_1234567890 * & rrr, xxx_type2_1234567890 * & r4, 
xxx_type_1234567890 * & defvars, xxx_type_1234567890 * & defvarsType) {
		ofstream * o = parF->back(); 
		Expect(7);
		unsigned int npar = 0;
		
		
			bool b = false; 
			bool c = false;
			bool dummyb = false;
			string sc;
			bool isIter = false;
			string * iterHighConst = new string("");
		
							vector<string> * iterStackFile = new vector<string>();
							vector<string> * iterStackInclFile = new vector<string>();
							vector<string> * iterStackInclFile2 = new vector<string>();
							
							if (state)
							{
							
								*o << "{" << endl;
							
							}				
						
						
		if (la->kind == 16) {
			SequentialComposition();
		} else if (la->kind == 28) {
			ParallelComposition(b);
		} else if (la->kind == 29) {
			ChoiceComposition(c);
		} else SynErr(46);
		if (c)
		{
		
			int typ = 0;
			string * s = new string("");
			vector<string> * var = new vector<string>();
			bool idOnly = true;
			vector<string> * rside = new vector<string>();
			string * pre = new string("");
		
				string * s2 = new string("");
		
		
		Term(typ,s,var,idOnly,rside,defvars,pre,defvarsType, false);
		if (la->kind == 21) {
			Get();
			Term(typ, s, var, idOnly, rside, defvars, pre, defvarsType, true);
		}
		Expect(22);
		if(rside->empty() || idOnly)
		{
		}
		else
		{
		
											// test ci je premenna definovana
		
											defN++;
		
											vector<string>::size_type n = rside->size();
											vector<string>::size_type m = defvars->size();
		
											char * c = new char[80];
											itoa(defN, c, 10);
		
											s2->append("HANDLE defVar_xxx_handles");
											s2->append(c);
											s2->append("[defVar_xxx_numHandles");
											itoa(defN, c, 10);
											s2->append(c);
											s2->append("];\n\n");
		
											unsigned int z = 0;
		
											for (vector<string>::size_type i = 0; i < n; i++)
											{
		
												for (vector<string>::size_type k = 0; k < m; k++)
												{
		
													if (!(rside->at(i)).compare(defvars->at(k)))
													{
		
														s2->append("defVar_xxx_handles");
														itoa(defN, c, 10);
														s2->append(c);
														s2->append("[");
														itoa(z, c, 10);
														s2->append(c);
														s2->append("] = ");
														s2->append(rside->at(i));
														s2->append(".defined;\n");
		
														z++;
		
													}
		
												}
		
											}		
											
											s2->append("\n");
											s2->append("WaitForMultipleObjects(defVar_xxx_numHandles");
											itoa(defN, c, 10);
		
											*inclFile << "#define defVar_xxx_numHandles" << defN << " " << z << endl;
		
											s2->append(c);
											s2->append(", defVar_xxx_handles");
											s2->append(c);
											s2->append(", TRUE, INFINITE);\n \n");
										
										}														
		
								s->append(" )\n");
								pre->append("if(");
								pre->append(*s);
								s2->append(*pre);
								
								*o << endl << s2->c_str();
		
							}
					
							
		if (b) { 
		
							parNB++;
							parN++;
							string s = "parF";
							string sh = "parFHandle";
							sc = "parFnbConst";
							char * c = new char[80];
							itoa(parN, c, 10);
		
							sh.append(c);
							sc.append(c);
											
							
							string buf0 = "";	
							
							//*o << endl << "HANDLE " << "parFHandle" << parNB << "[parFnbConst" << parNB << "];" << endl << endl; 
							
							buf0.append("\n HANDLE parFHandle");
							
							itoa(parNB, c, 10);
							
							buf0.append(c);
							
							buf0.append("[parFnbConst");
							
							buf0.append(c);
							
							buf0.append("];\n \n");
																	
							s.append(c);
							
							string bufufu = "";
							//*o << s.c_str() << "a " << s.c_str() << "aa(";
							bufufu.append(s);
							bufufu.append("a ");
							
							iterStackFile->push_back(buf0);
							iterStackFile->push_back(bufufu);
							
							string buff0 = "";					
							
							buff0.append(s);
							buff0.append("aa");
							
							iterStackFile->push_back(buff0);
							
							string buff = "parFnbConst";
							buff.append(c);
							
							iterStackFile->push_back(buff);
							
							string buf = "";
							
							buf.append("(");
							
							for (vector<string>::size_type i = 0; i < defvars->size(); i++)
							{
							
								if (i < defvars->size() - 1)
								{
							
									//*o << defvars->at(i).c_str() << ", " ;
									buf.append(defvars->at(i));
									buf.append(", ");							
		
								}
								else
								{
							
									//*o << defvars->at(i).c_str() ;
									buf.append(defvars->at(i));
									buf.append(" ");
								
								}
							
							}
							
							iterStackFile->push_back(buf);
							
							string buf2 = "";
							 
							//*o << ");" << endl;
							buf2.append(");\n");
							
							iterStackFile->push_back(buf2);
							
							string buf3 = "";
							
							//inkrement staci tu lebo sa to tyka len jedneho bloku
							quantN++;
							//nasleduje makro pre pripad quantification
							//*o << "quantificationMacro" << quantN << endl;
							
							//*o << "parFHandle" << parNB << "[" << npar << "] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)" 
							//<< s.c_str() << ", & " << s.c_str() << "aa, 0, NULL);" << endl;
							
							buf3.append("parFHandle");
							
							itoa(parNB, c, 10);
							
							buf3.append(c);
							
							buf3.append("[");
							itoa(npar, c, 10);
							buf3.append(c);					
							buf3.append("] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)");
							buf3.append(s);
							buf3.append(", & ");
							buf3.append(s);
							buf3.append("aa, 0, NULL);\n");
							
							iterStackFile->push_back(buf3);
							
							//*o << "quantificationMacroEnd" << quantN << endl;
							
							// prepenem do dalsieho suboru a tam davam vystup
							
							
							parF->push_back(new ofstream());
							o = parF->back();
							o->open(s.c_str());
							
							string buf4 = "";
							
							//*o << "#include \"defvar.h\"" << endl << "#include \"incl_data.h\"" << endl << endl;
							buf4.append("#include \"defvar.h\"\n #include \"incl_data.h\"\n \n");
							
							vector<string>::size_type n = ext->size();
							
							for (vector<string>::size_type i = 0; i < n; i++)
							{
							
								//*o << (ext->at(i)).c_str();
								buf4.append(ext->at(i));
								
							}
						
							//*o << endl << endl;
							buf4.append("\n \n");
						
							string bufI = "";
						
							//*inclFile << "class " << s.c_str() << "a" << endl << "{" << endl << endl << "public:" << endl
							//<< s.c_str() << "a(";
							bufI.append("class ");
							bufI.append(s);
							bufI.append("a\n { \n \n public: \n");
							bufI.append(s);
							bufI.append("a(");
							
							string bufII = "";					
							
							//*inclFile2 << s.c_str() << "a::" << s.c_str() << "a(";
							
							bufII.append(s);
							bufII.append("a::");
							bufII.append(s);
							bufII.append("a(");
							
							for (vector<string>::size_type i = 0; i < defvars->size(); i++)
							{
							
								if (i < defvars->size() - 1)
								{
							
									//*inclFile << "	DefVar" << defvarsType->at(i).c_str() << " & " 
									//	<< defvars->at(i).c_str() << "1, " << endl;
									
									bufI.append("	DefVar");
									bufI.append(defvarsType->at(i));
									bufI.append(" & ");
									bufI.append(defvars->at(i));
									bufI.append("1, \n");								
										
									//*inclFile2 << "	DefVar" << defvarsType->at(i).c_str() << " & " 
									//	<< defvars->at(i).c_str() << "1, " << endl;
									
									bufII.append("	DefVar");
									bufII.append(defvarsType->at(i));
									bufII.append(" & ");
									bufII.append(defvars->at(i));
									bufII.append("1, \n");
		
								}
								else
								{
							
									//*inclFile << "	DefVar" << defvarsType->at(i).c_str() << " & " 
									//	<< defvars->at(i).c_str() << "1 " <<  endl;
										
									bufI.append("	DefVar");
									bufI.append(defvarsType->at(i));
									bufI.append(" & ");
									bufI.append(defvars->at(i));
									bufI.append("1 \n");
																	
									//*inclFile2 << "	DefVar" << defvarsType->at(i).c_str() << " & " 
									//	<< defvars->at(i).c_str() << "1 " <<  endl;
										
									bufII.append("	DefVar");
									bufII.append(defvarsType->at(i));
									bufII.append(" & ");
									bufII.append(defvars->at(i));
									bufII.append("1 ");
															
								}
		
							}			
							
							iterStackInclFile->push_back(bufI);
							iterStackInclFile2->push_back(bufII);
							
							string bufI2 = "";
							string bufII2 = "";										
							
							//*inclFile << ");" << endl << endl;
							
							bufI2.append(" );\n \n");
							
							//*inclFile2 << "):" << endl ;
							
							bufII2.append("): \n");
		
							for (vector<string>::size_type i = 0; i < defvars->size(); i++)
							{
							
								if (i < defvars->size() - 1)
								{
							
									//*inclFile2 << defvars->at(i).c_str() << "(" 
									//	<< defvars->at(i).c_str() << "1), " << endl;
									bufII2.append(defvars->at(i));
									bufII2.append("(");
									bufII2.append(defvars->at(i));
									bufII2.append("1), \n");							
		
								}
								else
								{
							
									//*inclFile2 << defvars->at(i).c_str() << "(" 
									//	<< defvars->at(i).c_str() << "1) " <<  endl;
									bufII2.append(defvars->at(i));
									bufII2.append("(");
									bufII2.append(defvars->at(i));
									bufII2.append("1) ");
								
								}
		
							}			
							
							iterStackInclFile->push_back(bufI2);
							iterStackInclFile2->push_back(bufII2);
							
							string bufI3 = "";
							string bufII3 = "";					
							
							//*inclFile2 << "{" << endl << "}" << endl << endl;
							bufII3.append("\n{\n }\n \n");
							
							
							//*inclFile << s.c_str() << "a(const " << s.c_str() << "a & a);" << endl << endl;
							bufI3.append(s);
							bufI3.append("a(const ");
							bufI3.append(s);
							bufI3.append("a & a);\n \n");
							
							//*inclFile << s.c_str() << "a() {};" << endl << endl;
							bufI3.append(s);
							bufI3.append("a() {};\n \n");					
												
							//*inclFile2 << s.c_str() << "a::" << s.c_str() << "a(const " << s.c_str() << "a & a):" << endl;
							bufII3.append(s);
							bufII3.append("a::");
							bufII3.append(s);
							bufII3.append("a(const ");
							bufII3.append(s);
							bufII3.append("a & a):\n");
					
		
							for (vector<string>::size_type i = 0; i < defvars->size(); i++)
							{
							
								if (i < defvars->size() - 1)
								{
							
									//*inclFile2 << defvars->at(i).c_str() << "(a." 
									//	<< defvars->at(i).c_str() << "1), " << endl;
									bufII3.append(defvars->at(i));
									bufII3.append("(a.");
									bufII3.append(defvars->at(i));
									bufII3.append("), \n");//1
		
								}
								else
								{
							
									//*inclFile2 << defvars->at(i).c_str() << "(a." 
									//	<< defvars->at(i).c_str() << "1) " <<  endl;
									bufII3.append(defvars->at(i));
									bufII3.append("(a.");
									bufII3.append(defvars->at(i));
									bufII3.append(") ");//1
								
								}
		
							}			
							
							iterStackInclFile->push_back(bufI3);
							iterStackInclFile2->push_back(bufII3);
							
							string bufI4 = "";
							string bufII4 = "";
							
							//*inclFile2 << "{" << endl << "}" << endl << endl;
							bufII4.append("\n{\n }\n \n");
							
							for (vector<string>::size_type i = 0; i < defvars->size(); i++)
							{
							
								//*inclFile << "	DefVar" << defvarsType->at(i).c_str() << " & " 
								//<< defvars->at(i).c_str() << ";" << endl;
								bufI4.append("	DefVar");
								bufI4.append(defvarsType->at(i));
								bufI4.append(" & ");
								bufI4.append(defvars->at(i));
								bufI4.append(";\n");
							
							}
							
							iterStackInclFile->push_back(bufI4);
							iterStackInclFile2->push_back(bufII4);
							
							string bufI5 = "";
							string bufII5 = "";
							
							//*inclFile << endl << endl	<< "};" << endl << endl << endl;
							bufI5.append("\n \n };\n \n");
							
							iterStackInclFile->push_back(bufI5);
							iterStackInclFile->push_back(bufII5);
		
							//*o << "void WINAPI " << s.c_str() << "( " << s.c_str() << "a & " << s.c_str() 
							//<< "aa )" << endl << "{" << endl;
							
							buf4.append("void WINAPI ");
							buf4.append(s);
							buf4.append("( ");
							buf4.append(s);
							buf4.append("a & ");
							buf4.append(s);
							buf4.append("aa )\n {\n");
							
							for (vector<string>::size_type i = 0; i < defvars->size(); i++ )
							{
							
								//*o << "DefVar" << defvarsType->at(i).c_str() << " & " << defvars->at(i).c_str() << " = " 
								//	<< s.c_str() << "aa." << defvars->at(i).c_str() << ";" << endl;
								buf4.append("DefVar");
								buf4.append(defvarsType->at(i));
								buf4.append(" & ");
								buf4.append(defvars->at(i));
								buf4.append(" = ");
								buf4.append(s);
								buf4.append("aa.");
								buf4.append(defvars->at(i));
								buf4.append(";\n");						
							
							}
							
							iterStackFile->push_back(buf4);
							
							string buf5 = "\n \n";
												
							//*o << endl << endl;
							
							iterStackFile->push_back(buf5);
							
							delete [] c;
						}
						else
						{
						
							quantN++;
											
						}
						
						
		Block(r, rr, rrr, r4, defvars, defvarsType, iterStackFile, iterStackInclFile, 
iterStackInclFile2, b, isIter, iterHighConst);
		if(b){
		*o << endl << "}";
		 o->close();
		parF->pop_back();
		o = parF->back();
		}
		
		
		while (la->kind == 17) {
			Get();
			if(c)
			{
			
				int typ = 0;
				string * s = new string("");
				vector<string> * var = new vector<string>();
				bool idOnly = true;
				vector<string> * rside = new vector<string>();
				string * pre = new string("");
			
					string * s2 = new string("");
					
					defaultt = false;
								
			
			Term(typ,s,var,idOnly,rside,defvars,pre,defvarsType, false);
			if (la->kind == 21) {
				Get();
				Term(typ,s,var,idOnly,rside,defvars,pre,defvarsType, true);
			}
			Expect(22);
			if (!defaultt)
			{
					if(rside->empty() || idOnly)
					{
					}
					else
					{
			
												// test ci je premenna definovana
			
												defN++;
			
												vector<string>::size_type n = rside->size();
												vector<string>::size_type m = defvars->size();
			
												char * c = new char[80];
												itoa(defN, c, 10);
			
												s2->append("HANDLE defVar_xxx_handles");
												s2->append(c);
												s2->append("[defVar_xxx_numHandles");
												itoa(defN, c, 10);
												s2->append(c);
												s2->append("];\n\n");
			
												unsigned int z = 0;
			
												for (vector<string>::size_type i = 0; i < n; i++)
												{
			
													for (vector<string>::size_type k = 0; k < m; k++)
													{
			
														if (!(rside->at(i)).compare(defvars->at(k)))
														{
			
															s2->append("defVar_xxx_handles");
															itoa(defN, c, 10);
															s2->append(c);
															s2->append("[");
															itoa(z, c, 10);
															s2->append(c);
															s2->append("] = ");
															s2->append(rside->at(i));
															s2->append(".defined;\n");
			
															z++;
			
														}
			
													}
			
												}		
												
												s2->append("\n");
												s2->append("WaitForMultipleObjects(defVar_xxx_numHandles");
												itoa(defN, c, 10);
			
												*inclFile << "#define defVar_xxx_numHandles" << defN << " " << z << endl;
			
												s2->append(c);
												s2->append(", defVar_xxx_handles");
												s2->append(c);
												s2->append(", TRUE, INFINITE);\n \n");
											
											}
										
									
										pre->append("if(");
										s->append(" )\n");
										pre->append(*s);
										s2->append(*pre);
										*o << endl << "else" << endl << "{" << endl << s2->c_str() ;
			
									}
									else
									{
									
										*o << "else" << endl << "{" << endl;
										defaultt = false;
									
									}
									
			
								}		
							
							
								if(b) {
								parN++;
								npar++;
								string s = "parF";
								string sh = "parFHandle";
								sc = "parFnbConst";
								char * c = new char[80];
								itoa(parN, c, 10);
								
			
								sh.append(c);
								sc.append(c);					
								
			
								s.append(c);
								
								string buf = "";
								
								
								*o << s.c_str() << "a " << s.c_str() << "aa(";
								
								
								
								for (vector<string>::size_type i = 0; i < defvars->size(); i++)
								{
								
									if (i < defvars->size() - 1)
									{
								
										*o << defvars->at(i).c_str() << ", " ;
			
									}
									else
									{
								
										*o << defvars->at(i).c_str()  ;
									
									}
								
								}
								
								*o << ");" << endl;
								
								*o << "parFHandle" << parNB << "[" << npar << "] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)" << s.c_str() << ", & " << s.c_str() << "aa, 0, NULL);" << endl;					
			
								parF->push_back(new ofstream());
								o = parF->back();
								o->open(s.c_str());
			
								*o << "#include \"defvar.h\"" << endl << "#include \"incl_data.h\"" << endl << endl;
								
								vector<string>::size_type n = ext->size();
								
								for (vector<string>::size_type i = 0; i < n; i++)
								{
								
									*o << (ext->at(i)).c_str();
									
								}
							
								*o << endl << endl;
							
								*inclFile << "class " << s.c_str() << "a" << endl << "{" << endl << endl << "public:" << endl
								<< s.c_str() << "a(";
								
								*inclFile2 << s.c_str() << "a::" << s.c_str() << "a(";
								
								for (vector<string>::size_type i = 0; i < defvars->size(); i++)
								{
								
									if (i < defvars->size() - 1)
									{
								
										*inclFile << "	DefVar" << defvarsType->at(i).c_str() << " & " 
											<< defvars->at(i).c_str() << "1, " << endl;
										*inclFile2 << "	DefVar" << defvarsType->at(i).c_str() << " & " 
											<< defvars->at(i).c_str() << "1, " << endl;
			
									}
									else
									{
								
										*inclFile << "	DefVar" << defvarsType->at(i).c_str() << " & " 
											<< defvars->at(i).c_str() << "1 " <<  endl;
										*inclFile2 << "	DefVar" << defvarsType->at(i).c_str() << " & " 
											<< defvars->at(i).c_str() << "1 " <<  endl;
									
									}
			
								}					
								
								*inclFile << ");" << endl << endl;
								*inclFile2 << "):" << endl ;
			
								for (vector<string>::size_type i = 0; i < defvars->size(); i++)
								{
								
									if (i < defvars->size() - 1)
									{
								
										*inclFile2 << defvars->at(i).c_str() << "(" 
											<< defvars->at(i).c_str() << "1), " << endl;
			
									}
									else
									{
								
										*inclFile2 << defvars->at(i).c_str() << "(" 
											<< defvars->at(i).c_str() << "1) " <<  endl;
									
									}
			
								}			
								
								*inclFile2 << "{" << endl << "}" << endl << endl;		
			
								*inclFile << s.c_str() << "a(const " << s.c_str() << "a & a);" << endl << endl;
								
								*inclFile2 << s.c_str() << "a::" << s.c_str() << "a(const " << s.c_str() << "a & a):" << endl;
			
								for (vector<string>::size_type i = 0; i < defvars->size(); i++)
								{
								
									if (i < defvars->size() - 1)
									{
								
										*inclFile2 << defvars->at(i).c_str() << "(a." 
											<< defvars->at(i).c_str() << "), " << endl;//1
			
									}
									else
									{
								
										*inclFile2 << defvars->at(i).c_str() << "(a." 
											<< defvars->at(i).c_str() << ") " <<  endl;//1
									
									}
			
								}			
								
								*inclFile2 << "{" << endl << "}" << endl << endl;
			
								for (vector<string>::size_type i = 0; i < defvars->size(); i++)
								{
								
									*inclFile << "	DefVar" << defvarsType->at(i).c_str() << " & " << defvars->at(i).c_str() << ";" << endl;
								
								}
								
								*inclFile << endl << endl	<< "};" << endl << endl << endl;
			
								*o << "void WINAPI " << s.c_str() << "( " << s.c_str() << "a & " << s.c_str() << "aa )" << endl << "{" << endl;
								
								for (vector<string>::size_type i = 0; i < defvars->size(); i++ )
								{
								
									//*o << rrr->at(i)->c_str() << " = " << s.c_str() << "aa." << r4->at(i)->c_str() << ";" << endl;
									*o << "DefVar" << defvarsType->at(i).c_str() << " & " << defvars->at(i).c_str() << " = " 
										<< s.c_str() << "aa." << defvars->at(i).c_str() << ";" << endl;
								
								}
			
								
								*o << endl << endl;
			
								delete [] c;
			
								}
								else
								{
			
									//*o << ";" << endl;
			
								}
							
			Block(r, rr, rrr, r4, defvars, defvarsType, iterStackFile, iterStackInclFile, iterStackInclFile2,
dummyb, dummyb, iterHighConst);
			if(c){
			
			*o << endl << "}";
			
			}
			
								if(b){
								*o << endl << "}"; 
			
								 o->close(); 
								parF->pop_back();
								o = parF->back();}
			
							
		}
		Expect(23);
		if (b)
		{
		
								if (isIter)
								{
								
									*inclFile << endl << "#define parFnbConst" << parNB << " " << iterHighConst->c_str() << endl << endl;
									*o << endl << "}" << endl
										<< "WaitForMultipleObjects(" << "parFnbConst" << parNB << ", parFHandle" << parNB 
										<< ", TRUE, INFINITE);" << endl << endl;
								
								}
								else
								{
								
									*inclFile << endl << "#define parFnbConst" << parNB << " " << npar+1 << endl << endl;
									*o << endl << "WaitForMultipleObjects(" << npar+1 << ", parFHandle" << parNB 
										<< ", TRUE, INFINITE);" << endl << endl;
									
								}
							}
						
							if (state)
							{
							
								*o << "}" << endl;
							
							}
							
						
}

void Parser::MutableDeclaration(unsigned int & type, string * & r, string * & rr, xxx_type2_1234567890 * & rrr, 
xxx_type2_1234567890 * & r4, xxx_type_1234567890 * & defvars, xxx_type_1234567890 * & defvarsType, 
string * & post) {
		ofstream * o = parF->back();
		string * hlpl = new string("");
		
		
		Expect(1);
		*o << t->val ;
		hlpl->append(t->val);
		
									rrr->push_back(new string(""));
									r4->push_back(new string(""));
		
									switch(type)
									{
									case 0:	r->append("int & ");
											(rrr->back())->append("int & ");
										break;
									case 1:	r->append("double & ");
											(rrr->back())->append("double & ");
										break;
									case 2:	r->append("char & ");
											(rrr->back())->append("char & ");
										break;
									case 3:	r->append("port & ");
											(rrr->back())->append("port & ");
										break;
									case 4:	defvars->push_back(t->val);
											tab->push_back(t->val);
										break;
									}
		
									r->append(t->val);
									r->append(";");
									r->append("\n");
									
									(rrr->back())->append(t->val);
									(r4->back())->append(t->val);
																
									rr->append(t->val);
		
									int typ;
									string * s = new string("");
		
								 
		if (la->kind == 19) {
			Get();
			vector<string> * var = new vector<string>();
			bool idOnly = true;
			vector<string> * rside = new vector<string>();
			string * pre = new string("");
			
								
			if (StartOf(2)) {
				Expression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			}
			post->append(*hlpl);
			post->append(".val = new ");
			
			string * s23 = new string(defvarsType->back());
			s23->erase(0,1);
			s23->erase(s23->rfind("*"), s23->size() - 1);
			post->append(*s23);
			post->append("[");
			post->append(s->c_str());
			post->append("];");
			
								
			Expect(20);
		}
}

void Parser::Expression(int & typ, string * & s, xxx_type_1234567890 * & var, bool & idOnly,
xxx_type_1234567890 * & rside, xxx_type_1234567890 * & defvars, string * & pre, xxx_type_1234567890 * & defvarsType) {
		MultyplyingExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
		MoreTerms(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
}

void Parser::SequentialComposition() {
		Expect(16);
}

void Parser::ParallelComposition(bool & b) {
		Expect(28);
		b = true; 
		
		 
}

void Parser::ChoiceComposition(bool & b) {
		Expect(29);
		b = true; 
}

void Parser::Term(int & typ, string * & s, xxx_type_1234567890 * & var, bool & idOnly, xxx_type_1234567890 * & rside, 
xxx_type_1234567890 * & defvars, string * & pre, xxx_type_1234567890 * & defvarsType, bool gatherMode) {
		if (StartOf(2)) {
			Expression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
		} else if (la->kind == 4) {
			Get();
			s->append(t->val); 
			typ = 5;
			idOnly = false;
			
			
		} else if (la->kind == 7) {
			bool st = false; // st == if we started to construct a tuple
			bool tn = false; // tn == true if we have a nested tuple
							
			
			TupleConstructor(tn, st, s, var, idOnly, rside, defvars, pre, defvarsType, gatherMode);
			idOnly = false;
			
			
		} else if (la->kind == 19) {
			bool st = false; // st == if we started to construct a tuple
			bool tn = false; // tn == true if we have a nested tuple
							
			
			ListConstructor(typ, tn, st, s, var, idOnly, rside, defvars, pre, defvarsType);
			idOnly = false;
			
			
		} else SynErr(47);
}

void Parser::Block(string * & r, string * & rr, xxx_type2_1234567890 * & rrr, xxx_type2_1234567890 * & r4, 
xxx_type_1234567890 * & defvars, xxx_type_1234567890 * & defvarsType,
xxx_type_1234567890 * & iterStackFile, xxx_type_1234567890 * & iterStackInclFile,
xxx_type_1234567890 * & iterStackInclFile2, bool & parComp, bool & isIter, string * iterHighConst) {
		if (la->kind == 17 || la->kind == 23) {
		} else if (la->kind == 1) {
			ofstream * o = parF->back(); 
			bool dummyb = false;
			bool ggg = true;
			int typ = 0;
			string * dummys = new string("");
			
			
						vector<string> * i1 = new vector<string>();
						vector<string> * i2 = new vector<string>();
						vector<string> * i3 = new vector<string>();
						
						
					
			string * s = new string("");
			vector<string> * rside = new vector<string>();
			vector<string> * var = new vector<string>();
			bool idOnly = true;
			string * sd = new string("");
			
							bool b = false;
							string * s1 = new string("");
							string * s2 = new string("");
			
							string * pre = new string("");
			
							bool iter = false;
			
							string * iters = new string("");
							string * iters2 = new string("");
							string * iterpre = new string("");
							string * iterpre2 = new string("");
							string * expr = new string("");
							string * expr2 = new string("");
							
							
						
			Variable(s, var, idOnly, sd, rside, defvars, pre, defvarsType);
			rside = new vector<string>();
			
			vector<string> * rside2 = new vector<string>();
			vector<string> * rside3 = new vector<string>();
			
			
			if (la->kind == 10 || la->kind == 26 || la->kind == 27) {
				if (la->kind == 26 || la->kind == 27) {
					if (la->kind == 26) {
						AssignmentStatement(s, rside, defvars, defvarsType, expr, dummyb);
					} else if (la->kind == 27) {
						DefinitionStatement(s, b, rside, defvars, defvarsType);
					} else SynErr(48);
				} else {
					Get();
					IterBoundary(s1, rside2, defvars, defvarsType, expr, ggg);
					Expect(24);
					IterBoundary(s2, rside3, defvars, defvarsType, expr2, ggg);
					Expect(25);
					if (parComp)
					{
					
					
					
						iterHighConst->append(expr2->c_str());
						iterHighConst->append(" - ");
						iterHighConst->append(expr->c_str());
						iterHighConst->append(" + 1");
					
						ofstream * ox = parF->back();
						parF->pop_back();
						ofstream * oox = parF->back();
						
						*ox << iterStackFile->at(7).c_str()	<< "DefVar<int> " << s->c_str() << " = " << iterStackFile->at(2).c_str()
							<< "." << s->c_str() << ";" << endl << iterStackFile->at(8).c_str();										
						
						*oox << endl << "int " << s->c_str() << ";" << endl << iterStackFile->at(0).c_str()
							<< iterStackFile->at(1).c_str()
							<< " " << iterStackFile->at(2).c_str() 
							<< "[" << iterStackFile->at(3).c_str() << "];" << endl						
							<< "for (" << s->c_str() << " = " << expr->c_str() << "; " << s->c_str() << " <= " 
							<< iterHighConst->c_str() << ";)" << endl << "{" << endl 
							<< iterStackFile->at(2).c_str() << "[" << s->c_str() << "]" << " = " << iterStackFile->at(1).c_str()
							<< iterStackFile->at(4).c_str() << ", " << s->c_str() << ");" << endl
							<< iterStackFile->at(6).c_str();
							
						parF->push_back(ox);
						
						
						
						*inclFile	<< iterStackInclFile->at(0).c_str()
									<< "," << endl << "DefVar<int> " << s->c_str() << "1"
									<< iterStackInclFile->at(1).c_str()
									<< iterStackInclFile->at(2).c_str()
									<< iterStackInclFile->at(3).c_str()
									<< "DefVar<int> " << s->c_str() << ";"
									<< iterStackInclFile->at(4).c_str()
									<< iterStackInclFile->at(5).c_str();
									
						
					
										
										*inclFile2	<< iterStackInclFile2->at(0).c_str()
													<< "," << endl << "DefVar<int> " << s->c_str() << "1"
													<< iterStackInclFile2->at(1).c_str()
													<< "," << endl << s->c_str() << "(" << s->c_str() << "1)"
													<< iterStackInclFile2->at(2).c_str()
													<< "," << endl << s->c_str() << "(a." << s->c_str() << "1)"
													<< iterStackInclFile2->at(3).c_str();
													
										
									
									}
									
									isIter = true;
									iter = true;
											
									if (!parComp)
									{
									
										*o << "for (int " << s->c_str() << " = " << expr->c_str() << "; i <= " << expr2->c_str() << ";)"
											<< endl << "{" << endl << endl;
									
									}
									
								
					Block(r, rr, rrr, r4, defvars, defvarsType, i1, i2, i3, dummyb, dummyb, dummys);
					if (!parComp && iter)
					{
					
						*o << endl << "}" << endl << endl;
					
					}
					
								
								
				}
			}
			if (parComp && !iter)
			{
			
				ofstream * ox = parF->back();
				parF->pop_back();
				ofstream * oox = parF->back();
				
				*ox << iterStackFile->at(7).c_str()	<< iterStackFile->at(8).c_str();
				
				*oox << iterStackFile->at(0).c_str() << iterStackFile->at(1).c_str()
					<< iterStackFile->at(2).c_str() << iterStackFile->at(4).c_str()
					<< iterStackFile->at(5).c_str() << iterStackFile->at(6).c_str();
					
				parF->push_back(ox);
				
				for (vector<string>::size_type i = 0; i < iterStackInclFile->size(); i++)
				{
				
					*inclFile	<< iterStackInclFile->at(i).c_str();
							
				}
			
								
								for (vector<string>::size_type i = 0; i < iterStackInclFile2->size(); i++)
								{
			
									*inclFile2	<< iterStackInclFile2->at(i).c_str();
											
								}
							
							}
							
			
							if (!iter)
							{
			
							*o << pre->c_str() ;
			
							*o << s->c_str();
							}
							
							
							
							if (b)
							{
							
								*o << endl << "SetEvent(" << sd->c_str() << ".defined);" << endl << endl;
							
							}
							else
							{
							
								*o << ";" << endl << endl;
							
							}
							
							delete s;
							delete sd;
							
											
						
		} else if (la->kind == 7) {
			bool s = true;
			if (isIter) s = false;
			
			
			ProgramBody(s, r, rr, rrr, r4, defvars, defvarsType);
		} else SynErr(49);
}

void Parser::Variable(string * & s, xxx_type_1234567890 * & var, bool & idOnly, string * & sd, xxx_type_1234567890 * & rside, 
xxx_type_1234567890 * & defvars, string * & pre, xxx_type_1234567890 * & defvarsType) {
		Expect(1);
		sd->append(t->val);								
		
										string * s2 = new string(t->val);
		
										bool b = false;
		
										vector<string>::size_type n = tab->size();
										vector<string> * varr = new vector<string>();
										
										bool istuple = false;
		
										for (vector<string>::size_type i = 0; i < n; i++)
										{
		
											string & st = tab->at(i);
		
											if (st.compare(t->val) == 0)
											{
		
												b = true;										
		
											}
		
										}
		
										n = defvars->size();
		
										for (vector<string>::size_type i = 0; i < n; i++)
										{
										
											if (!defvars->at(i).compare(t->val) && !defvarsType->at(i).compare("<Tuple>"))
											{
											
												istuple = true;
											
											}
										
										}
		
										if (b)
										{
		
											var->push_back(t->val);
		
										}
										
										idOnly = true && idOnly;
										
										bool fc = false; // fc == function call
										bool idx = false; // idx == index
										string * stl = new string("");
		
									
		if (la->kind == 6 || la->kind == 19) {
			if (la->kind == 19) {
				idx = true;
				
				if (istuple)
				{
				}
				else
				{
					
					stl->append("[");
					
				}
				
				
				Get();
				Index(stl, defvars, defvarsType, rside);
				Expect(20);
				if (istuple)
				{
				}
				else
				{
				
						stl->append("]");
						
					}
					
				
			} else {
				Get();
				fc = true;
				s2->append(" ( "); 
				
				
				if (la->kind == 18) {
					Get();
					s2->append(" ) "); 
				} else if (StartOf(3)) {
					
					Arguments(s2, varr, defvars, pre, defvarsType);
					Expect(18);
					s2->append(" ) ");
					
					if (varr->empty())
					{
					}
					else
					{																	
							defN++;
							
							vector<string>::size_type n = varr->size();
									
							char * c = new char[80];
							itoa(defN, c, 10);
							
							string * strng = new string("");
														
							strng->append("HANDLE defVar_xxx_handles");
							strng->append(c);
							itoa(n, c, 10);
							strng->append("[");
							strng->append("defVar_xxx_numHandles");
							itoa(defN, c, 10);									
							strng->append(c);
							strng->append("];\n \n");
							
							*inclFile << "#define defVar_xxx_numHandles" << defN << " " << n << endl;
																
							for(vector<string>::size_type i = 0; i < n; i++)
							{
							
								strng->append("defVar_xxx_handles");
								itoa(defN, c, 10);
								strng->append(c);
								strng->append("[");
								itoa(i, c, 10);
								strng->append(c);
								strng->append("] = ");
								strng->append(varr->at(i));
								strng->append(".defined;\n");
																
							}		
							
							strng->append("\n");
							strng->append("WaitForMultipleObjects(defVar_xxx_numHandles");
							itoa(defN, c, 10);
							strng->append(c);
							strng->append(", defVar_xxx_handles");
							strng->append(c);
							strng->append(", TRUE, INFINITE);\n \n");
							
							strng->append(*pre);
							pre = strng;
						
					}
					
					
					
					s->append(*s2);
					
					
				} else SynErr(50);
			}
		}
		if (fc)
		{
		}
		else
		{
		
			if (istuple && idx)
			{
			
				s->append("// Here you have to cast to the right class manualy and also the setevent\n");
			
				s->append("((Obj");
				
				//s->append(typ prvku);		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				//riesenie
				//urob strom ktory zachyta strukturu tuply
				
				s->append(" * )(");
			
			}
		
										s->append(*sd);
										
										if (b)
										{
										
											bool bbb = false;
											vector<string>::size_type k;
										
											vector<string>::size_type n = defvars->size();
											
											for (vector<string>::size_type i = 0; i < n; i++)
											{
											
												if (!sd->compare(defvars->at(i)) && !defvarsType->at(i).compare("<Tuple>"))
												{
												
													bbb = true;
													k = i;
												
												}
											
											}
											
											/*if ((istuple && !idx) || (!istuple && idx))
											{
											
												s->append(".val");
												
											}
											
											if (istuple && idx)
											{
											
												s->append(".Read(");
												s->append(*stl);
												s->append(")))->val");
											
											}*/
		
											s->append(".val");
											
											if(idx && !bbb)
											{
																				
												s->append(*stl);
												
											}
											
											
										
										}
										
										
										
										rside->push_back(*sd);
									
											if(idx && !b)
											{
											
												s->append(*stl);
											
											}
									
										
									}
								
								
}

void Parser::AssignmentStatement(string * & str, xxx_type_1234567890 * & rside, 
xxx_type_1234567890 * & defvars, xxx_type_1234567890 * & defvarsType, string * & expr, bool & ggg) {
		ofstream * o = parF->back(); 
		Expect(26);
		str->append(" = ");
		int typ;
		string * s = new string("");	
		string * s2 = new string("");
		vector<string> * var = new vector<string>();	
		bool idOnly = true;					
		
		string * pre = new string("");
		
		
		
		Expression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
		expr->append(*s);
		
			if(rside->empty() || idOnly)
			{
			}
			else
			{
		
											// test ci je premenna definovana
		
											defN++;
		
											vector<string>::size_type n = rside->size();
											vector<string>::size_type m = defvars->size();
		
											char * c = new char[80];
											itoa(defN, c, 10);
		
											s2->append("HANDLE defVar_xxx_handles");
											s2->append(c);
											s2->append("[defVar_xxx_numHandles");
											itoa(defN, c, 10);
											s2->append(c);
											s2->append("];\n\n");
		
											unsigned int z = 0;
		
											for (vector<string>::size_type i = 0; i < n; i++)
											{
		
												for (vector<string>::size_type k = 0; k < m; k++)
												{
		
													if (!(rside->at(i)).compare(defvars->at(k)))
													{
		
														s2->append("defVar_xxx_handles");
														itoa(defN, c, 10);
														s2->append(c);
														s2->append("[");
														itoa(z, c, 10);
														s2->append(c);
														s2->append("] = ");
														s2->append(rside->at(i));
														s2->append(".defined;\n");
		
														z++;
		
													}
		
												}
		
											}		
											
											s2->append("\n");
											s2->append("WaitForMultipleObjects(defVar_xxx_numHandles");
											itoa(defN, c, 10);
		
											*inclFile << "#define defVar_xxx_numHandles" << defN << " " << z << endl;
		
											s2->append(c);
											s2->append(", defVar_xxx_handles");
											s2->append(c);
											s2->append(", TRUE, INFINITE);\n \n");
										
										}
										
										if (ggg)
										{
									
											s2->append(*pre);
											s2->append(*str);
											str = s2;
										
										}
										else
										{
									
											s->append(";");
											str->append(*s);
											s2->append(*pre);
											s2->append(*str);
											str = s2;
										
										}
									
									 
}

void Parser::DefinitionStatement(string * & str, bool & bbbb, xxx_type_1234567890 * & rside, 
xxx_type_1234567890 * & defvars, xxx_type_1234567890 * & defvarsType) {
		ofstream * o = parF->back(); 
		Expect(27);
		bbbb = true;
			
		str->append(" = ");
		int typ;
		string * s = new string("");
		string * s2 = new string("");
		string * pre = new string("");
			
		vector<string> * var = new vector<string>();
		bool idOnly = true;
		
				
		
		Term(typ, s, var, idOnly, rside, defvars, pre, defvarsType, false);
		if(rside->empty() || idOnly)
		{
		}
		else
		{
		
			// test ci je premenna definovana
			
			defN++;
			
			vector<string>::size_type n = rside->size();
			vector<string>::size_type m = defvars->size();
					
			char * c = new char[80];
			itoa(defN, c, 10);
										
			s2->append("HANDLE defVar_xxx_handles");
			s2->append(c);
			s2->append("[defVar_xxx_numHandles");
			itoa(defN, c, 10);
			s2->append(c);
			s2->append("];\n\n");
													
			unsigned int z = 0;
												
			for (vector<string>::size_type i = 0; i < n; i++)
			{
			
				for (vector<string>::size_type k = 0; k < m; k++)
				{
			
					if (!(rside->at(i)).compare(defvars->at(k)))
					{
		
														s2->append("defVar_xxx_handles");
														itoa(defN, c, 10);
														s2->append(c);
														s2->append("[");
														itoa(z, c, 10);
														s2->append(c);
														s2->append("] = ");
														s2->append(rside->at(i));
														s2->append(".defined;\n");
														
														z++;
													
													}
												
												}
																				
											}		
											
											s2->append("\n");
											s2->append("WaitForMultipleObjects(defVar_xxx_numHandles");
											itoa(defN, c, 10);
		
											*inclFile << "#define defVar_xxx_numHandles" << defN << " " << z << endl;
		
											s2->append(c);
											s2->append(", defVar_xxx_handles");
											s2->append(c);
											s2->append(", TRUE, INFINITE);\n \n");
										
										}
									
										s->append(";");
										str->append(*s);
										s2->append(*pre);
										s2->append(*str);
										str = s2;
									
								
}

void Parser::IterBoundary(string * & str, xxx_type_1234567890 * & rside, 
xxx_type_1234567890 * & defvars, xxx_type_1234567890 * & defvarsType, string * & expr, bool & ggg) {
		ofstream * o = parF->back(); 
		str->append(" = ");
		int typ;
		string * s = new string("");	
		string * s2 = new string("");
		vector<string> * var = new vector<string>();	
		bool idOnly = true;					
		
		string * pre = new string("");
		
		
		
		Expression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
		expr->append(*s);
		
			if(rside->empty() || idOnly)
			{
			}
			else
			{
		
											// test ci je premenna definovana
		
											defN++;
		
											vector<string>::size_type n = rside->size();
											vector<string>::size_type m = defvars->size();
		
											char * c = new char[80];
											itoa(defN, c, 10);
		
											s2->append("HANDLE defVar_xxx_handles");
											s2->append(c);
											s2->append("[defVar_xxx_numHandles");
											itoa(defN, c, 10);
											s2->append(c);
											s2->append("];\n\n");
		
											unsigned int z = 0;
		
											for (vector<string>::size_type i = 0; i < n; i++)
											{
		
												for (vector<string>::size_type k = 0; k < m; k++)
												{
		
													if (!(rside->at(i)).compare(defvars->at(k)))
													{
		
														s2->append("defVar_xxx_handles");
														itoa(defN, c, 10);
														s2->append(c);
														s2->append("[");
														itoa(z, c, 10);
														s2->append(c);
														s2->append("] = ");
														s2->append(rside->at(i));
														s2->append(".defined;\n");
		
														z++;
		
													}
		
												}
		
											}		
											
											s2->append("\n");
											s2->append("WaitForMultipleObjects(defVar_xxx_numHandles");
											itoa(defN, c, 10);
		
											*inclFile << "#define defVar_xxx_numHandles" << defN << " " << z << endl;
		
											s2->append(c);
											s2->append(", defVar_xxx_handles");
											s2->append(c);
											s2->append(", TRUE, INFINITE);\n \n");
										
										}
										
										if (ggg)
										{
									
											s2->append(*pre);
											s2->append(*str);
											str = s2;
										
										}
										else
										{
									
											s->append(";");
											str->append(*s);
											s2->append(*pre);
											s2->append(*str);
											str = s2;
										
										}
									
									 
}

void Parser::Arguments(string * & s, xxx_type_1234567890 * var, xxx_type_1234567890 * & defvars, string * & pre, 
xxx_type_1234567890 * & defvarsType) {
		int typ;
		vector<string> * varr = new vector<string>();
		bool idOnly = true;
		vector<string> * rside = new vector<string>();
		string * str = new string("");
		unsigned int zzz = 0;
		
								
		Term(typ, str, varr, idOnly, rside, defvars, pre, defvarsType, false);
		if (idOnly)
		{
		
			s->append(rside->back());
		
			varr->clear();
		
		}
		else
		{
		
			if (varr->empty())
			{
		
		
										}
										else
										{																	
										
											defN++;
										
											pre->append("DefVar");
		
											//typ argumentu
											pre->append(defvarsType->at(zzz));
										
											
											pre->append(" ");
											pre->append("help");
											
											char * c = new char[80];
											itoa(defN, c, 10);
											
											pre->append(c);
											pre->append(";\n");
										
											pre->append("help");
											pre->append(c);
											pre->append(".val = ");
											pre->append(*str);
											pre->append("; \n \n");
											pre->append("SetEvent(help");
											pre->append(c);
											pre->append(".defined);\n \n");
											
											s->append("help");
											s->append(c);
		
											for (vector<string>::size_type i = 0; i < varr->size(); i++)
											{
		
												var->push_back(varr->at(i));
		
											}
		
		
										}
		
									}
		
								
		while (la->kind == 17) {
			Get();
			zzz++;
			s->append(", ");
			varr = new vector<string>();
			idOnly = true;
			str = new string("");
			
									
			Term(typ, str, varr, idOnly, rside, defvars, pre, defvarsType, false);
			if (idOnly)
			{
			
				s->append(rside->back());
			
				varr->clear();
			
			}
			else
			{
			
				if (varr->empty())
				{
			
			
											}
											else
											{
																			
												defN++;
											
												pre->append("DefVar");
												
												pre->append(defvarsType->at(zzz));								
												
												pre->append(" ");
												pre->append("help");
												
												char * c = new char[80];
												itoa(defN, c, 10);
												
												pre->append(c);
												pre->append(";\n");
											
												pre->append("help");
												pre->append(c);
												pre->append(".val = ");
												pre->append(*str);
												pre->append("; \n \n");
												pre->append("SetEvent(help");
												pre->append(c);
												pre->append(".defined);\n \n");
												
												s->append("help");
												s->append(c);
												
			
												for (vector<string>::size_type i = 0; i < varr->size(); i++)
												{
			
													var->push_back(varr->at(i));
			
												}
			
			
											}
			
										}
			
									
		}
}

void Parser::Index(string * & stl, xxx_type_1234567890 * & defvars, xxx_type_1234567890 * & defvarsType, xxx_type_1234567890 * & rside) {
		if (la->kind == 2) {
			Get();
			stl->append(t->val); 
		} else if (la->kind == 1) {
			Get();
			stl->append(t->val);
			
			vector<string>::size_type n = defvars->size();
			
			for (vector<string>::size_type i = 0; i < n; i++)
			{
			
			if (!defvars->at(i).compare(t->val))
			{
			
				stl->append(".val");
				rside->push_back(t->val);
			
			}
			
			}
			
			
		} else SynErr(51);
}

void Parser::MultyplyingExpression(int & typ, string * & s, xxx_type_1234567890 * & var, bool & idOnly, 
xxx_type_1234567890 * & rside, xxx_type_1234567890 * & defvars, string * & pre, xxx_type_1234567890 * & defvarsType) {
		PrimaryExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
		MoreMultiply(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
}

void Parser::MoreTerms(int & typ, string * & s, xxx_type_1234567890 * & var, bool & idOnly, 
xxx_type_1234567890 * & rside, xxx_type_1234567890 * & defvars, string * & pre, xxx_type_1234567890 * & defvarsType) {
		switch (la->kind) {
		case 17: case 18: case 20: case 21: case 22: case 23: case 24: case 25: {
			break;
		}
		case 30: {
			Get();
			s->append(" + "); 
			idOnly = false;
			
			
			MultyplyingExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreTerms(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			break;
		}
		case 31: {
			Get();
			s->append(" - ");
			idOnly = false;
			
			
			MultyplyingExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreTerms(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			break;
		}
		case 32: {
			Get();
			s->append(" < ");
			idOnly = false;
			
			
			MultyplyingExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreTerms(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			break;
		}
		case 33: {
			Get();
			s->append(" > ");
			idOnly = false;
			
			
			MultyplyingExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreTerms(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			break;
		}
		case 34: {
			Get();
			s->append(" >= ");
			idOnly = false;
			
			
			MultyplyingExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreTerms(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			break;
		}
		case 35: {
			Get();
			s->append(" <= ");
			idOnly = false;
			
			
			MultyplyingExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreTerms(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			break;
		}
		case 36: {
			Get();
			s->append(" == ");
			idOnly = false;
			
			
			MultyplyingExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreTerms(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			break;
		}
		case 37: {
			Get();
			s->append(" != ");
			idOnly = false;
			
			
			MultyplyingExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreTerms(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			break;
		}
		case 28: {
			Get();
			s->append(" || ");
			idOnly = false;
			
			
			MultyplyingExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreTerms(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			break;
		}
		default: SynErr(52); break;
		}
}

void Parser::PrimaryExpression(int & typ, string * & s, xxx_type_1234567890 * & var, bool & idOnly, xxx_type_1234567890 * & rside, 
xxx_type_1234567890 * & defvars, string * & pre, xxx_type_1234567890 * & defvarsType) {
		if (la->kind == 1) {
			string * sd = new string(""); 
			Variable(s, var, idOnly, sd, rside, defvars, pre, defvarsType);
		} else if (la->kind == 2 || la->kind == 5 || la->kind == 31) {
			SignedNumber(typ, s);
			idOnly = false;
			
			
		} else if (la->kind == 42) {
			Get();
			Expect(6);
			Expect(1);
			Expect(18);
			idOnly = false;
			
			
		} else if (la->kind == 43) {
			Get();
			defaultt = true;
			idOnly = false;
			
			
		} else if (la->kind == 6) {
			Get();
			int typ;
			s->append(" ( ");
			idOnly = false;
			
			
			Expression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			Expect(18);
			s->append(" ) ");
			
			 
		} else SynErr(53);
}

void Parser::MoreMultiply(int & typ, string * & s, xxx_type_1234567890 * & var, bool & idOnly, xxx_type_1234567890 * & rside, 
xxx_type_1234567890 * & defvars, string * & pre, xxx_type_1234567890 * & defvarsType) {
		if (StartOf(4)) {
		} else if (la->kind == 38) {
			Get();
			s->append(" * ");
			idOnly = false;
			
			
			PrimaryExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreMultiply(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
		} else if (la->kind == 39) {
			Get();
			s->append(" / ");
			idOnly = false;
			
			
			PrimaryExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreMultiply(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
		} else if (la->kind == 40) {
			Get();
			s->append(" % ");
			idOnly = false;
			
			
			PrimaryExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreMultiply(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
		} else if (la->kind == 41) {
			Get();
			s->append(" && ");
			idOnly = false;
			
				
			PrimaryExpression(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
			MoreMultiply(typ, s, var, idOnly, rside, defvars, pre, defvarsType);
		} else SynErr(54);
}

void Parser::SignedNumber(int & typ, string * & s) {
		if (la->kind == 31) {
			Get();
			s->append(" - "); 
		}
		if (la->kind == 2) {
			Get();
			typ = 0;
			s->append(t->val);
			
			
		} else if (la->kind == 5) {
			Get();
			typ = 1;						
			s->append(t->val);
			
			
		} else SynErr(55);
}

void Parser::TupleConstructor(bool & tn, bool & st, string * & s, xxx_type_1234567890 * & var, bool & idOnly,
xxx_type_1234567890 * & rside, xxx_type_1234567890 * & defvars, string * & pre, 
xxx_type_1234567890 * & defvarsType, bool gatherMode) {
		Expect(7);
		tupN++;
		tupleN->push_back(tupN);
		tupleN->push_back(0);
		
		string gn = string("tupleVar");
		char * c = new char[80];
		itoa(tupN, c, 10);
		gn.append(c);
		
		if (!st)
		{
			s->append(gn);
		}
		
		pre->append("vector<void *> * ");
		pre->append(gn);
		pre->append(" = new vector<void *>();\n");
		//pre->append(gn);
		//pre->append(".MakeTuple(tupleVarN");
		//pre->append(c);
		//pre->append(");\n \n");
		int typ;
		
								if (st)
								{
								
									pre->append("tupleVar");
									
									itoa(tupleN->at(tupleN->size() - 4), c, 10);
									
									pre->append(c);
									pre->append("->push_back(");
									pre->append(gn);
									pre->append(");\n \n");
								
								}
														
							
								if (!st)
								{
								
									st = true;
								
								}
								else
								{
								
									tn = true;
								
								}
							
							
		Elements(typ, tn, st, s, var, idOnly, rside, defvars, pre, defvarsType);
		Expect(23);
		unsigned int cn = tupleN->back();
		tupleN->pop_back();
		unsigned int nb = tupleN->back();
		tupleN->pop_back();
		
			*inclFile << "#define tupleVarN" << nb << " " << cn << endl;
			
			switch(typ)
			{
			
			case 0:	*inclFile << "#define tupleVarT" << nb << " " << "int" << endl;
					break;
			
			case 1: *inclFile << "#define tupleVarT" << nb << " " << "double" << endl;
					break;
			
			}
			
		
}

void Parser::ListConstructor(int & typ, bool & tn, bool & st, string * & s, xxx_type_1234567890 * & var, bool & idOnly,
xxx_type_1234567890 * & rside, xxx_type_1234567890 * & defvars, string * & pre, 
xxx_type_1234567890 * & defvarsType) {
		Expect(19);
		tupN++;
		tupleN->push_back(tupN);
		tupleN->push_back(0);
		
		string gn = string("tupleVar");
		char * c = new char[80];
		itoa(tupN, c, 10);
		gn.append(c);
		
		if (!st)
		{
			s->append(gn);
		}
		
		pre->append("vector<void *> * ");
		pre->append(gn);
		pre->append(" = new vector<void *>();\n");
		//pre->append(gn);
		//pre->append(".MakeTuple(tupleVarN");
		//pre->append(c);
		//pre->append(");\n \n");
		//int typ;
		
								if (st)
								{
								
									pre->append("tupleVar");
									
									itoa(tupleN->at(tupleN->size() - 4), c, 10);
									
									pre->append(c);
									pre->append("->push_back(");
									pre->append(gn);
									pre->append(");\n \n");
								
								}
														
							
								if (!st)
								{
								
									st = true;
								
								}
								else
								{
								
									tn = true;
								
								}
							
							
		Elements(typ, tn, st, s, var, idOnly, rside, defvars, pre, defvarsType);
		if (la->kind == 44) {
			Get();
			Element(typ, tn, st, s, var, idOnly, rside, defvars, pre, defvarsType);
		}
		Expect(20);
		unsigned int cn = tupleN->back();
		tupleN->pop_back();
		unsigned int nb = tupleN->back();
		tupleN->pop_back();
		
			*inclFile << "#define tupleVarN" << nb << " " << cn << endl;
			
			switch(typ)
			{
			
			case 0:	*inclFile << "#define tupleVarT" << nb << " " << "int" << endl;
					break;
			
			case 1: *inclFile << "#define tupleVarT" << nb << " " << "double" << endl;
					break;
			
			}
			
		
}

void Parser::Elements(int & typ, bool & tn, bool & st, string * & s, xxx_type_1234567890 * & var, bool & idOnly, xxx_type_1234567890 * & rside, 
xxx_type_1234567890 * & defvars, string * & pre, xxx_type_1234567890 * & defvarsType) {
		Element(typ, tn, st, s, var, idOnly, rside, defvars, pre, defvarsType);
		(tupleN->back())++;
		
		
		while (la->kind == 17) {
			Get();
			Element(typ, tn, st, s, var, idOnly, rside, defvars, pre, defvarsType);
			(tupleN->back())++;
			
			
		}
}

void Parser::Element(int & typ, bool & tn, bool & st, string * & s, xxx_type_1234567890 * & var, bool & idOnly, xxx_type_1234567890 * & rside, 
xxx_type_1234567890 * & defvars, string * & pre, xxx_type_1234567890 * & defvarsType) {
		if (la->kind == 2 || la->kind == 5 || la->kind == 31) {
			string * stt = new string("");
			
			
			SignedNumber(typ, stt);
			vector<unsigned int>::size_type z = tupleN->size();
			unsigned int n = tupleN->at(z-2);
			unsigned int i = tupleN->at(z-1);
			
				char * c = new char[80];
				itoa(n, c, 10);
						
				if (typ == 0)
				{
			
					pre->append("tupleVar");
					pre->append(c);
					pre->append("->push_back(");
					pre->append("new DefVar<int>());\n");					
					pre->append("*((DefVar<int> *)(tupleVar");
				
				}
				else
				{
				
					pre->append("tupleVar");
					pre->append(c);
					pre->append("->push_back(");
					pre->append("new DefVar<double>());\n");					
					pre->append("*((DefVar<double> *)(tupleVar");
				
				}
				
				itoa(n, c, 10);
				
				pre->append(c);
				pre->append("->at(");
				
				itoa(i, c, 10);
				
				pre->append(c);
				
				pre->append("))->val) = ");
				pre->append(*stt);
				pre->append(";\n");
				
				if (typ == 0)
				{
				
					pre->append("SetEvent((DefVar<int> *)(tupleVar");
					
				}
				else
				{
				
					pre->append("SetEvent((DefVar<double> *)(tupleVar");
				
				}
				
				itoa(n, c, 10);
				
				pre->append(c);
				pre->append("->at(");
				
				itoa(i, c, 10);
				
				pre->append(c);
				
				pre->append("))->defined);\n");
				
			
			
		} else if (la->kind == 4) {
			Get();
			vector<unsigned int>::size_type z = tupleN->size();
			unsigned int n = tupleN->at(z-2);				
			
				char * c = new char[80];
				itoa(n, c, 10);
				
				pre->append("_xxx_char_var_helper_var0123456789 = new char[strlen(");
				pre->append(t->val);
				pre->append(")+1];\n strcpy(_xxx_char_var_helper_var0123456789, ");
				pre->append(t->val);
				pre->append(");\n");
				pre->append("_xxx_char_var_helper_var0123456789[strlen(");
				pre->append(t->val);
				pre->append(")] = \'\\0\';\n");
						
				pre->append("tupleVar");
				pre->append(c);
				pre->append("->push_back(_xxx_char_var_helper_var0123456789);\n");
				
			
		} else if (la->kind == 7) {
			TupleConstructor(tn, st, s, var, idOnly, rside, defvars, pre, defvarsType, true);
		} else if (la->kind == 19) {
			ListConstructor(typ, tn, st, s, var, idOnly, rside, defvars, pre, defvarsType);
		} else if (la->kind == 1) {
			string * sd = new string("");
			
						
			Variable(s, var, idOnly, sd, rside, defvars, pre, defvarsType);
			vector<unsigned int>::size_type z = tupleN->size();
			unsigned int n = tupleN->at(z-2);				
			
				char * c = new char[80];
				itoa(n, c, 10);
						
				pre->append("tupleVar");
				pre->append(c);
				pre->append("->push_back(&");
				pre->append(sd->c_str());
				pre->append(");\n");				
			
			
		} else SynErr(56);
}



void Parser::Parse() {
	t = NULL;
	la = dummyToken = new Token();
	la->val = coco_string_create("Dummy Token");
	Get();
	Pcn();

	Expect(0);
}

Parser::Parser(Scanner *scanner) {
	_EOF = 0;
	_id = 1;
	_intConstant = 2;
	_charConstant = 3;
	_charStringConstant = 4;
	_doubleConstant = 5;
	_bracket = 6;
	_bracket2 = 7;
	_anyType = 8;
	_anyCom = 9;
	_over = 10;
	maxT = 45;
	bool lset[5][47] = {
		{T,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
		{x,x,x,x, x,x,x,x, x,x,x,T, T,T,T,T, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
		{x,T,T,x, x,T,T,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,T, x,x,x,x, x,x,x,x, x,x,T,T, x,x,x},
		{x,T,T,x, T,T,T,T, x,x,x,x, x,x,x,x, x,x,x,T, x,x,x,x, x,x,x,x, x,x,x,T, x,x,x,x, x,x,x,x, x,x,T,T, x,x,x},
		{x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,T,T,x, T,T,T,T, T,T,x,x, T,x,T,T, T,T,T,T, T,T,x,x, x,x,x,x, x,x,x}
	};

	set = new bool*[5];
	for(int i=0; i<5; i++) {
		set[i] = new bool[47];
		for(int j=0; j<47; j++) {
			set[i][j] = lset[i][j];
		}
	}

	minErrDist = 2;
	errDist = minErrDist;
	this->scanner = scanner;
	errors = new Errors();
}

Parser::~Parser() {
	for(int i=0; i<5; i++) {
		delete set[i];
	}

	delete set;
	delete errors;
	delete dummyToken;
}

Errors::Errors() {
	count = 0;
}

void Errors::SynErr(int line, int col, int n) {
	char* s;
	switch (n) {
			case 0: s = coco_string_create("EOF expected"); break;
			case 1: s = coco_string_create("id expected"); break;
			case 2: s = coco_string_create("intConstant expected"); break;
			case 3: s = coco_string_create("charConstant expected"); break;
			case 4: s = coco_string_create("charStringConstant expected"); break;
			case 5: s = coco_string_create("doubleConstant expected"); break;
			case 6: s = coco_string_create("bracket expected"); break;
			case 7: s = coco_string_create("bracket2 expected"); break;
			case 8: s = coco_string_create("anyType expected"); break;
			case 9: s = coco_string_create("anyCom expected"); break;
			case 10: s = coco_string_create("over expected"); break;
			case 11: s = coco_string_create("\"int\" expected"); break;
			case 12: s = coco_string_create("\"double\" expected"); break;
			case 13: s = coco_string_create("\"char\" expected"); break;
			case 14: s = coco_string_create("\"port\" expected"); break;
			case 15: s = coco_string_create("\"DefVar\" expected"); break;
			case 16: s = coco_string_create("\";\" expected"); break;
			case 17: s = coco_string_create("\",\" expected"); break;
			case 18: s = coco_string_create("\")\" expected"); break;
			case 19: s = coco_string_create("\"[\" expected"); break;
			case 20: s = coco_string_create("\"]\" expected"); break;
			case 21: s = coco_string_create("\"?=\" expected"); break;
			case 22: s = coco_string_create("\"->\" expected"); break;
			case 23: s = coco_string_create("\"}\" expected"); break;
			case 24: s = coco_string_create("\"..\" expected"); break;
			case 25: s = coco_string_create("\"::\" expected"); break;
			case 26: s = coco_string_create("\":=\" expected"); break;
			case 27: s = coco_string_create("\"=\" expected"); break;
			case 28: s = coco_string_create("\"||\" expected"); break;
			case 29: s = coco_string_create("\"?\" expected"); break;
			case 30: s = coco_string_create("\"+\" expected"); break;
			case 31: s = coco_string_create("\"-\" expected"); break;
			case 32: s = coco_string_create("\"<\" expected"); break;
			case 33: s = coco_string_create("\">\" expected"); break;
			case 34: s = coco_string_create("\">=\" expected"); break;
			case 35: s = coco_string_create("\"<=\" expected"); break;
			case 36: s = coco_string_create("\"==\" expected"); break;
			case 37: s = coco_string_create("\"!=\" expected"); break;
			case 38: s = coco_string_create("\"*\" expected"); break;
			case 39: s = coco_string_create("\"/\" expected"); break;
			case 40: s = coco_string_create("\"%\" expected"); break;
			case 41: s = coco_string_create("\"&&\" expected"); break;
			case 42: s = coco_string_create("\"length\" expected"); break;
			case 43: s = coco_string_create("\"default\" expected"); break;
			case 44: s = coco_string_create("\"|\" expected"); break;
			case 45: s = coco_string_create("??? expected"); break;
			case 46: s = coco_string_create("invalid ProgramBody"); break;
			case 47: s = coco_string_create("invalid Term"); break;
			case 48: s = coco_string_create("invalid Block"); break;
			case 49: s = coco_string_create("invalid Block"); break;
			case 50: s = coco_string_create("invalid Variable"); break;
			case 51: s = coco_string_create("invalid Index"); break;
			case 52: s = coco_string_create("invalid MoreTerms"); break;
			case 53: s = coco_string_create("invalid PrimaryExpression"); break;
			case 54: s = coco_string_create("invalid MoreMultiply"); break;
			case 55: s = coco_string_create("invalid SignedNumber"); break;
			case 56: s = coco_string_create("invalid Element"); break;

		default:
		{
			char format[20];
			sprintf(format, "error %d", n);
			s = coco_string_create(format);
		}
		break;
	}
	printf("-- line %d col %d: %s\n", line, col, s);
	coco_string_delete(s);
	count++;
}

void Errors::SemErr(int line, int col, int n) {
	char s[20];
	sprintf(s, "error %d", n);
	printf("-- line %d col %d: %s\n", line, col, s);
	count++;
}

void Errors::Error(int line, int col, char* s) {
	printf("-- line %d col %d: %s\n", line, col, s);
	count++;
}

void Errors::Exception(char* s) {
	printf("%s", s); 
	exit(1);
}



